/*************************************************/
/*	Author: Bram van Dijk (November 2016)    */
/*************************************************/
///////////////////////////////////////////////////
///////////////////////////////////////////////////
// 	       Displaying a grid in C/CPP 	      	 //
///////////////////////////////////////////////////
///////////////////////////////////////////////////

/* 

   How to use 

   You can plug this display into any grid-based 
   program. The extern 2D array MyGrid is used 
   to draw the grid, so if you want to have your
   own grid drawn, just transfer your grid to 
   this grid. 
   
   The testgrid slowly changes to have all the
   same color, which can also be achieved by 
   clicking a pixel. You should also try out 
   the keystrokes keystrokes t, s and q!

   Compatible with both C and CPP:
     > gpp -o XGrid Grid.cpp -lX11 -ljpeg
     > g++ -o XGrid Grid.cpp -lX11 -ljpeg

*/

#include <stdio.h>
#include <stdlib.h>

#include "X11_With_Color.cpp"

extern int** MyGrid;
int width = 8, height = 8, scale = 70, margin=20, i, j, t;

void UpdateMyGrid();

int main()
{
        InitializeGrid(width,height);
        Initialize_X(width*scale, height*scale, margin, scale);    // Initialise window of right size

        for(t=0; t<1000000;t++)
        {
                UpdateMyGrid();	  	// Update MyGrid to match 
                DisplayGrid();     // Displays grid
                CatchEvents();    	// Detects mouse clicks and keyboard presses. You can even detect which pixel is clicked.
        }
}

void UpdateMyGrid()
{
        for(i=0;i<width*scale;i++)
                for(j=0;j<width*scale;j++)
                {
                        if(rand()%3000000==0) MyGrid[i/scale][j/scale] = 1;
                }
}

