/* this program incorporates (and can combine) two mechanisms of convergent extension: blokjes and targetvector. If so desired, a growth zone is implemented from a third celltype, which divides and differentiates.*/

#include "Header.hh"
#include "Agent.hh"
#include "IO.hh"
#include "Misc.hh"
#include <sys/stat.h>
#include <signal.h>

#include "X11_With_Color.hpp"


void UpdateMyGrid();
int** MyGrid;
int Xzoom = 2;

/**********************************************************/
/**************** Catch abort ***********************/
/**********************************************************/

void my_function_to_handle_aborts(int signal_number)
{
    printf("\n\nCaught user abort, closing display..\n\n\n");

    printf("Do you want to show the plots? (y/n)\n");
            char input;
            cin >> input;
            if (input == 'Y' || input == 'y' || input == 'yes')
                system("sed -i 's/-nan/0.0/g' OutputTable.dat; xmgrace -batch gracebat.bfile -noask&");
            else printf("\nNot showing the plots, if you want them later, type \"xmgrace -batch gracebat.bfile -noask\"\n\n"), system("sed -i 's/-nan/0.0/g' OutputTable.dat");

    exit(128+signal_number);
}
/**********************************************************/
/**************** program variables ***********************/
/**********************************************************/



struct stat sb;        //allows to check for the existence of directories
int order;             //neighbourhoodorder
dsfmt_t dsfmt;
dsfmt_t dsfmt_output;

//char despath[]="testrun";
/**********************************************************/
/******************* functions ****************************/
/**********************************************************/


void Start(int argc, char **argv)
{
  char command[]="mkdir ";
  char makedirname[50];

 ReadPars(argc, argv);
  //cout<<"seedinitpop: "<<seedinitpop<<endl;
  dsfmt_init_gen_rand(&dsfmt, seed);
  //dsfmt_init_gen_rand(&dsfmt, seedmutations);

  /*** make directory if necessary ***/
  if (stat(despath, &sb) == 0 && S_ISDIR(sb.st_mode)){//directory exists, just check if the cells directory exists.
    //do nothing
  }

  else if(stat(despath, &sb) == 0 && !S_ISDIR(sb.st_mode)){//file exists but is not a directory
    printf("given file is not a directory. give another name\n");
    exit(1);
  }
  else{ //directory does not exist: make it.
    strcpy(makedirname,command);
    strcat(makedirname,despath);
    if(system(makedirname)==-1){ //make directory for data
      printf("warning: could not make directory %s. Exiting...\n",despath);
      exit(1);
    }
  }


}


int main(int argc, char **argv)
{
  Start(argc,argv);

  signal(SIGINT, my_function_to_handle_aborts);

  Agent *A=new Agent();
  InitializeGrid(2*A->W*Xzoom,A->L*Xzoom);
  printf("Grid initialized\n");
  Initialize_X(2*A->W*Xzoom,A->L*Xzoom,30,1);

  /** do stuff with agent **/
  A->DevelopAgent(despath);
  Close_X();
  delete A;
  my_function_to_handle_aborts(1);

  return 0;
}
